//This file is part of AcetoneISO. Copyright 2006,2007,2008,2009 Marco Di Antonio and Fabrizio Di Marco (acetoneiso@gmail.com)
//
//    AcetoneISO is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    AcetoneISO is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with AcetoneISO.  If not, see <http://www.gnu.org/licenses/>.


// funzione che imposta la cartella del database e la scannerizza
/*void acetoneiso::database()
{
 QDir Home = QDir::home();
 QString database_folder = QFileDialog::getExistingDirectory(this, tr("AcetoneISO::Select Database Folder"),
                                                 Home.path() );
if ( database_folder.isNull() )
	{
	}
	else
	{
	 Home.cd(".acetoneiso");
	 QDir::setCurrent( Home.path() );
	 QFile database_file;
	 database_file.setFileName("database");
	
		if (!database_file.open(QIODevice::WriteOnly | QIODevice::Text))
		return;
		QTextStream out(&database_file);//apro il file database_file e ci scrivo dentro la stringa contenuta in database_folder
		out << (database_folder);

		QDir datfolder(database_folder);//dichiaro una cartella datfolder che ha il percorso di database_folder.mi servirà per l'entryList.
 

		listWidget->clear();
		QStringList filters;
		filters << "*.iso" << "*.nrg" << "*.bin" << "*.img" << "*.mdf";
		datfolder.setNameFilters(filters);
		QString listaa;
		int position = 1;
		foreach (listaa, datfolder.entryList( QStringList(filters), QDir::Files ))
			{
			 listWidget->insertItem(position, listaa);
			 position = position + 1 ;
			}

	}
}*/


// funzione iniziale che automaticamente aggiorna il display al primo avvio
void acetoneiso::initial_get_database()
{
		QDir Home = QDir::home();
		QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
		file.open(QIODevice::ReadOnly);//lo apro in sola lettura
		QString strd = (leggiRigo( 4, &file ));
		strd.remove(0,5);
		strd.chop(1);
		//qDebug() << strd;
		QDir datfolder( strd );
		listWidget->clear();
		QStringList filters;
		filters << "*.iso" << "*.nrg" << "*.bin" << "*.mdf" << "*.img";
		datfolder.setNameFilters( filters );
		QString listaa;
		int position = 1;
		foreach (listaa, datfolder.entryList( QStringList(filters), QDir::Files ))
			{
			 listWidget->insertItem(position, listaa);
			 position = position + 1 ;
			}
}

// funzione che monta l'immagine dal database
void acetoneiso::mdatabase(QListWidgetItem *item)
{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
file.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString strd = (leggiRigo( 4, &file ));
strd.remove(0,5);
strd.chop(1);
//controllo che se strd finisce con / allora si deve togliere.
if( strd.endsWith( "/" ) ) {
   strd.chop(1);
   }
QString isodamontare = ((strd) + "/" + (item->text()));//da ora ho in isodamontare il file con tutto il suo percorso.
QDir Temp = QDir::temp();
Temp.cd("acetoneiso");
QString percorsoTemp = Temp.path();
QFile Mtab("/etc/mtab");//dichiaro un file Mtab che sarebbe /etc/mtab
Mtab.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString str1 = (Mtab.readAll());//leggo il contenuto del file mtab

QFileInfo fi(isodamontare);
QString onlyfile = fi.fileName();
QFile getfile;
getfile.setFileName(isodamontare);
float bignum = getfile.size();

float divide;
divide = (bignum / 1000) / 1000 ;

QString percorsovirtuale;
int x = 1;
while( x < 8 ) {
   if( !str1.contains( Home.path() + "/virtual-drives/" + QString::number( x ) ) ) {
      percorsovirtuale = ( Home.path() + "/virtual-drives/" + QString::number( x ) );
      Monta( isodamontare, percorsovirtuale );
         while( FUse.waitForFinished() ) { //aspetto che finisca il processo fuse per controllare se è stata montata
         }
         openBrowser( percorsovirtuale, onlyfile, divide, percorsoTemp );
      break;
   }
   else {
      x++;
   }
}
if( x == 8 ) {
      QMessageBox::warning(this, "AcetoneISO::Warning",tr("All Virtual Drives are busy,\n"
							"Unmount some Virtual Drive first!"));
   }
}

//funzione che cancella le immagini dal database. la rimozione non è visiva ma fisica.
void acetoneiso::remove_fromDatabase()
{
if ( !listWidget->currentItem() == 0 )
	{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
file.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString strd = (leggiRigo( 4, &file ));
strd.remove(0,5);
strd.chop(1);
//controllo che se strd finisce con / allora si deve togliere.
if( strd.endsWith( "/" ) ) {
   strd.chop(1);
   }
	QDir datfolder( strd );//dichiaro la directory del database

	QString oggetto( listWidget->currentItem()->text() );//immagine selezionata 
	QFile immagine_corrente( strd + "/" + oggetto );

QMessageBox msgBox;
msgBox.setText(tr("You are about to delete ") + oggetto + (" ") + tr("\nAre You sure?"));
QPushButton *connectButton = msgBox.addButton(tr("Yes"), QMessageBox::ActionRole);
QPushButton *connectButton2 = msgBox.addButton(tr("No way!"), QMessageBox::ActionRole);
//msgBox.setStandardButtons(QMessageBox::("ISO File") | QMessageBox::("CD/DVD"));
msgBox.exec();
 if (msgBox.clickedButton() == connectButton) {
	int riga = listWidget->currentRow() ;
	listWidget->takeItem( riga  );

	immagine_corrente.remove();
	}
 else if (msgBox.clickedButton() == connectButton2) {

}

	}
else
QMessageBox::warning(this, "AcetoneISO::Warning",tr( "select an image to delete" ));
}


