//This file is part of AcetoneISO. Copyright 2006,2007,2008,2009 Marco Di Antonio and Fabrizio Di Marco (acetoneiso@gmail.com)
//
//    AcetoneISO is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    AcetoneISO is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with AcetoneISO.  If not, see <http://www.gnu.org/licenses/>.
/*Here is the function to read the options in ~/.acetoneiso/acetoneiso.conf file*/
#include"options.h"
//#include"../acetoneiso.h"
#include <QtGui> 
void optionsDiag::optionss()
{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
if( file.exists() ) {
   file.open(QIODevice::ReadOnly);//lo apro in sola lettura
   QTextStream in(&file);
   QString str1 = in.readLine();
   QString str2 = in.readLine();
   QString str3 = in.readLine();
   QString str4 = in.readLine();

   if(str1.contains("standard", Qt::CaseInsensitive)) {
      radioButton_5->setChecked(true);
   }
   else {
      radioButton_6->setChecked(true);
   }

   if(str2.contains("kaffeine", Qt::CaseInsensitive)) {
      radioButton_7->setChecked(true);
   }
   else {
      if(str2.contains("vlc", Qt::CaseInsensitive)) {
         radioButton_8->setChecked(true); //Caso vlc
      }
      else {
         radioButton->setChecked(true); //caso SMPlayer
      }
   }

   if(str3.contains("kde", Qt::CaseInsensitive)) {
      radioButton_9->setChecked(true);
   }
   else {
      radioButton_10->setChecked(true);
   }
   
      lineEdit->setText( str4.remove(0,5) );

 }
else {
   setDefaults();
   //optionss();//funzione ricorsiva lol lol lol lol lol lol lol .....lol così le impostazioni vengono applicate appena create!!!
 }
} 

void optionsDiag::update_options()
{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
file.remove();
file.open(QIODevice::ReadWrite );


if( radioButton_5->isChecked() ) {
   QTextStream out(&file);
   out << ( "ISO_FROM_FOLDER = standard\n" );
   }
else {
   QTextStream out(&file);
   out << ( "ISO_FROM_FOLDER = user    \n" );
   }

if( radioButton_7->isChecked() ) {
   QTextStream out(&file);
   out << ( "PLAYER = kaffeine\n" );
   }
else {
      if( radioButton_8->isChecked() ) {
         QTextStream out(&file);
         out << ( "PLAYER = vlc     \n" );
         }
      else {
         QTextStream out(&file);
         out << ( "PLAYER = smplayer \n" );
         }
      }

if( radioButton_9->isChecked() ) {
   QTextStream out(&file);
   out << ( "FILE_BROWSER = kde   \n" );
   }
else {
   QTextStream out(&file);
   out << ( "FILE_BROWSER = other \n" );
   }

QTextStream out(&file);
out << "DB = " <<( lineEdit->text() ) << "\n";
}

void optionsDiag::setDefaults()
{
   QDir Home = QDir::home();
   QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
   file.open(QIODevice::WriteOnly | QIODevice::Text);
   QTextStream out(&file);
   out << ( "ISO_FROM_FOLDER = standard\n" );
   out << ( "PLAYER = kaffeine\n" );
   out << ( "FILE_BROWSER = kde\n" );
   out << ( "DB = " + Home.path() + "\n" );
   file.close();
   optionss();
}

void optionsDiag::getDbDir()
{
QDir Home = QDir::home();
QString folder = QFileDialog::getExistingDirectory(this, tr("AcetoneISO::Select Database Folder"),
                                                 Home.path());
if (folder.isNull() ) {
return;
}
else
{
lineEdit->setText( folder );
}
}



