//This file is part of AcetoneISO. Copyright 2006,2007,2008,2009 Marco Di Antonio and Fabrizio Di Marco (acetoneiso@gmail.com)
//
//    AcetoneISO is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    AcetoneISO is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with AcetoneISO.  If not, see <http://www.gnu.org/licenses/>.
void acetoneiso::mount()
{
QDir Temp = QDir::temp();
Temp.cd("acetoneiso");
QString percorsoTemp = Temp.path();
QFile Mtab("/etc/mtab");//dichiaro un file Mtab che sarebbe /etc/mtab
Mtab.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString str1 = (Mtab.readAll());//leggo il contenuto del file mtab
QDir Home = QDir::home();// entro nella home dell'utente
QString isodamontare;
isodamontare = QFileDialog::getOpenFileName(this,tr("Open Image"), Home.path() , tr("Image Files (*.iso *.daa *.bin *.mdf *.ashdisc *.bwi *.b5i *.lcd *.img *.cdi *.cif *.p01 *.pdi *.nrg *.ncd *.pxi *.gi *.fcd *.vcd *.c2d)"));
if ( isodamontare.isNull() )  {
   }

else
{
//mi ricavo l'estensione dell'immagine
QFileInfo getinfo(isodamontare);
QString ext = getinfo.suffix();  // ext = "iso?mdf?xyz?"
		if (((ext != "iso") && (ext != "nrg")) && ((ext != "bin") && (ext != "img")) && (ext != "mdf")) {
 
QMessageBox msgBox;
msgBox.setText(tr("The image ") + isodamontare + tr(" can't be mounted. You must convert it to ISO or extract content to a folder.\nPlease choose what to do:\nnote: in the next dialog, you will have to select again the image. Sorry about this.") );
QPushButton *connectButton = msgBox.addButton(tr(" Convert to ISO "), QMessageBox::ActionRole);
QPushButton *connectButton2 = msgBox.addButton(tr(" Extract image to a folder "), QMessageBox::ActionRole);
//msgBox.setStandardButtons(QMessageBox::("ISO File") | QMessageBox::("CD/DVD"));
msgBox.exec();
 	if (msgBox.clickedButton() == connectButton) {
	converter();
	}
 	else if (msgBox.clickedButton() == connectButton2) {
	extract();
							   }
 														}

				
else
{

QString percorsovirtuale;
QFileInfo fi(isodamontare);
QString onlyfile = fi.fileName();
QFile getfile;
getfile.setFileName(isodamontare);
float bignum = getfile.size();

float divide;
divide = (bignum / 1000) / 1000 ;
int x = 1;

while( x < 8 ) {
   if( !str1.contains( Home.path() + "/virtual-drives/" + QString::number( x ) ) ) {
      percorsovirtuale = ( Home.path() + "/virtual-drives/" + QString::number( x ) );

      Monta( isodamontare, percorsovirtuale );
         while( FUse.waitForFinished() ) { //aspetto che finisca il processo fuse per controllare se è stata montata
         }
         openBrowser( percorsovirtuale, onlyfile, divide, percorsoTemp );
      break;
   }
   else {
      x++;
   }
}
if( x == 8 ) {
      QMessageBox::warning(this, "AcetoneISO::Warning",tr("All Virtual Drives are busy,\n"
							"Unmount some Virtual Drive first!"));
   }
 }
}
}
void acetoneiso::Monta( QString &image, QString &destination )
{
QString alog( QDir::home().path() + "/.acetoneiso/acetoneiso.log" );
//file di log
QFile log( alog );
FUse.setReadChannel(QProcess::StandardOutput);//imposto il canale di lettura del processo
FUse.setStandardOutputFile( alog,   QIODevice::Truncate );//l'output di va nel file alog
FUse.start("fuseiso",QStringList()  << image << destination << "-o" << "nonempty"  );
}

void acetoneiso::openBrowser( QString &destination, QString onlyfile, float divide, QString &temporary )
{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
   file.open(QIODevice::ReadOnly);//lo apro in sola lettura
   QString strc = (leggiRigo( 3, &file ));

QDir destDir( destination );

if( destDir.count() > 2 ) { //se il contenuto della cartella montata non è nullo
QIcon icona( ":/images/Aiso2.png");
	QDir Dest( destination ); 
	QString name = Dest.dirName(); // voglio il nome della periferica virtuale per sapere quale item inserire 
	listWidget_2->insertItem(name.toInt(), " VD-" + name + " " + onlyfile + "  " + QString::number(divide) + "MB");


	QFile f1(temporary + "/" + name);
	f1.open(QIODevice::WriteOnly | QIODevice::Text);
	QTextStream out(&f1);
	out << (" VD-" + name + " " + onlyfile + "  " + QString::number(divide) + "MB");
        if(strc.contains("kde", Qt::CaseInsensitive)) { 	// se nelle impostazioni ho come browser kde 
	BRowser.startDetached("kfmclient",QStringList() << "exec" << destination );
	}
	else {
	BRowser.startDetached("nautilus",QStringList() << destination );
	}
   }
}

void acetoneiso::umount()
{
if (!listWidget_2->currentItem() == 0)

{
QString oggetto(listWidget_2->currentItem()->text());
QChar periferica(oggetto[4]);
QString f1_string(periferica);//
QDir percorso = ( (QDir::home()).path() + "/virtual-drives/" + periferica );
QDir Temp = QDir::temp();

QFile f1;
f1.setFileName( Temp.path() + "/acetoneiso/" + f1_string );

FUsermount.start("fusermount",QStringList() << "-u" << "-z" << percorso.path() );

int riga = listWidget_2->currentRow() ;
listWidget_2->takeItem( riga  );
f1.remove();
}
else
QMessageBox::warning(this, "AcetoneISO::Warning",tr( "select an image to unmount from the virtual-drives display" ));
}




void acetoneiso::printOutumount(int, QProcess::ExitStatus)
	{
	int valore_uscita = FUsermount.exitCode();
	if(valore_uscita == 1)
	QMessageBox::critical(this, "AcetoneISO",tr("An error occurred while unmounting.\nThe image has been unmounted but it is highly recommended to close and reopen AcetoneISO to mount a new image.") );

	}


//messaggi


void acetoneiso::printOutfuseiso(int, QProcess::ExitStatus)
	{
	int valore_uscita = FUse.exitCode();
	if(!valore_uscita == 0)
	
	QMessageBox::critical (this, "AcetoneISO",tr("Error, could not mount image.\n\nSolution:\nTry converting the image to ISO or extract the content to a folder from the upper menu \"Image Conversion.\"\nNOTE: it is NOT possible to mount multi-sector images.\nFor more information, please visit official website: http://www.acetoneteam.org" ));
	}

void acetoneiso::cmlMount()
{
int argNumber = qApp->arguments().size();

if( argNumber > 1  ) { //se gli argomenti presenti sono maggiori di 2 incluso il nome del programma che è argv[0]!
//tabWidget->setCurrentIndex(1);
QString isodamontare = qApp->arguments().at(1) ; //prendo l'argomento 1 da linea di comando 
//qDebug() << "STO ESEGUENDO IL MOUNT DA COMMAND LINE";
QDir Home = QDir::home();

QDir Temp = QDir::temp();
Temp.cd("acetoneiso");
QString percorsoTemp = Temp.path();
QFile Mtab("/etc/mtab");//dichiaro un file Mtab che sarebbe /etc/mtab
Mtab.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString str1 = (Mtab.readAll());//leggo il contenuto del file mtab

QFileInfo fi(isodamontare);
QString onlyfile = fi.fileName();
QFile getfile;
getfile.setFileName(isodamontare);
float bignum = getfile.size();

float divide;
divide = (bignum / 1000) / 1000 ;

QString percorsovirtuale;
int x = 1;
while( x < 8 ) {
   if( !str1.contains( Home.path() + "/virtual-drives/" + QString::number( x ) ) ) {
      percorsovirtuale = ( Home.path() + "/virtual-drives/" + QString::number( x ) );
      Monta( isodamontare, percorsovirtuale );
         while( FUse.waitForFinished() ) { //aspetto che finisca il processo fuse per controllare se è stata montata
         }
         openBrowser( percorsovirtuale, onlyfile, divide, percorsoTemp );
      break;
   }
   else {
      x++;
   }
}
if( x == 8 ) {
      QMessageBox::warning(this, "AcetoneISO::Warning",tr("All Virtual Drives are busy,\n"
							"Unmount some Virtual Drive first!"));
   }
 }//chiusura dell'if
else {
   //qDebug() << "NON STO ESEGUENDO IL MOUNT DA COMMAND LINE";
   return;
  }
}

void acetoneiso::menuMount()
{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
file.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString strd = (leggiRigo( 4, &file ));
strd.remove(0,5);
strd.chop(1);
//controllo che se strd finisce con / allora si deve togliere.
if( strd.endsWith( "/" ) ) {
   strd.chop(1);
   }
QString isodamontare = ((strd) + "/" + fileDaMontare );

QDir Temp = QDir::temp();
Temp.cd("acetoneiso");
QString percorsoTemp = Temp.path();
QFile Mtab("/etc/mtab");//dichiaro un file Mtab che sarebbe /etc/mtab
Mtab.open(QIODevice::ReadOnly);//lo apro in sola lettura
QString str1 = (Mtab.readAll());//leggo il contenuto del file mtab

QFileInfo fi(isodamontare);
QString onlyfile = fi.fileName();
QFile getfile;
getfile.setFileName(isodamontare);
float bignum = getfile.size();

float divide;
divide = (bignum / 1000) / 1000 ;

QString percorsovirtuale;
int x = 1;
while( x < 8 ) {
   if( !str1.contains( Home.path() + "/virtual-drives/" + QString::number( x ) ) ) {
      percorsovirtuale = ( Home.path() + "/virtual-drives/" + QString::number( x ) );
      Monta( isodamontare, percorsovirtuale );
         while( FUse.waitForFinished() ) { //aspetto che finisca il processo fuse per controllare se è stata montata
         }
         openBrowser( percorsovirtuale, onlyfile, divide, percorsoTemp );
      break;
   }
   else {
      x++;
   }
}
if( x == 8 ) {
      QMessageBox::warning(this, "AcetoneISO::Warning",tr("All Virtual Drives are busy,\n"
							"Unmount some Virtual Drive first!"));
   }
 }//chiusura dell'if

