//This file is part of AcetoneISO. Copyright 2006,2007,2008,2009 Marco Di Antonio and Fabrizio Di Marco (acetoneiso@gmail.com)
//
//    AcetoneISO is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    AcetoneISO is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with AcetoneISO.  If not, see <http://www.gnu.org/licenses/>. 
void acetoneiso::psxrip()
{
QDir bin("/usr/bin");
QFile cdrdao;
QDir::setCurrent( bin.path() );
cdrdao.setFileName("cdrdao");

if (cdrdao.exists())
	{

     bool ok;
     QString text = QInputDialog::getText(this, tr("AcetoneISO::Insert cd/dvd device"),
                                          tr("Please specify your CD/DVD device. If you aren't sure just leave default.\nTypical devices are:\n/dev/cdrom or /dev/cdrom0 or /dev/cdrom1 or /dev/dvd and follow this symbolism."), QLineEdit::Normal,
                                          "/dev/cdrom", &ok);



if (ok && !text.isEmpty())
{


 QDir Home = QDir::home();
		 	QString fileName = QFileDialog::getSaveFileName(this, tr("AcetoneISO::Save BIN file"),
										Home.path() + "/AcetoneISO_PSX",
										tr("Images (*.bin)"));

			
			if ( fileName.isNull() )
			{
			}
			else
			{
		QString	filebin = fileName.append(".bin");
		QString	filetoc = fileName.append(".toc");
UMountcdrom.start("umount",QStringList()  << text);	
QString alog( QDir::home().path() + "/.acetoneiso/acetoneiso.log" );
//file di log
QFile log( alog );
PSxrip.setReadChannel(QProcess::StandardOutput);//imposto il canale di lettura del processo
PSxrip.setStandardOutputFile( alog,   QIODevice::Truncate );//l'output di va nel file alog		
PSxrip.start("cdrdao",QStringList()  << "read-cd" << "--read-raw" << "--datafile" << filebin << "--device" << text << "--driver" << "generic-mmc-raw" << filetoc);
			progBarra();
			
			}
			
			
		

	}
}
else
QMessageBox::warning(this, "AcetoneISO::Warning!",tr("no cdrdao found in /usr/bin"));
}

//messaggi
void acetoneiso::printOutpsx(int, QProcess::ExitStatus)
	{
	int valore_uscita = PSxrip.exitCode();
	if(valore_uscita == 0)
	QMessageBox::information(this, "AcetoneISO",tr("Process Succesfully Finished!"));
	else
	QMessageBox::critical(this, "AcetoneISO","Process Error Code: " + QString::number(valore_uscita) +  tr("\nDid you insert correct CD/DVD device?") );
	}


