//This file is part of AcetoneISO. Copyright 2006,2007,2008,2009 Marco Di Antonio and Fabrizio Di Marco (acetoneiso@gmail.com)
//
//    AcetoneISO is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    AcetoneISO is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with AcetoneISO.  If not, see <http://www.gnu.org/licenses/>.
void acetoneiso::vidgeneric()
{
QDir Home = QDir::home();
QString open;
open = QFileDialog::getOpenFileName(this,tr("Select Video"), Home.path() , tr("Video Files (*.avi *.mpg *.mpeg *.mov *.wmv *.flv *.asf *.rm )"));
if ( !open.isNull() ) {
   QString fileName = QFileDialog::getSaveFileName(this, tr("AcetoneISO::Save Video file"),
						          Home.path() + "/AcetoneISO_Video",
								       tr("Video (*.avi)"));
   if ( !fileName.isNull() ) {
      bool ok;
      int i = QInputDialog::getInteger(this, tr("AcetoneISO::Fixed Quant"),tr("Please insert the Fixed Quant number.\nLowering the number will result in a higher quality video."), 7, 2, 13, 1, &ok);
      if (!ok) {
         return;
        }
      else {
         QString quant;
         quant = QString::number(i).prepend("fixed_quant=" );
         QString file;
         file = fileName.append(".avi" );
         VIdgen.start("mencoder",QStringList()  << open << "-ovc" << "xvid" << "-oac" << "mp3lame" << "-xvidencopts" << quant << "-o" << file  );
         progBarra();
        }
       }
  }
}
//konsole --noclose -e mencoder "$OPENFILE" -ovc xvid -oac mp3lame -xvidencopts fixed_quant=7 -o "$OUT"
void acetoneiso::flvavi()
{
QDir Home = QDir::home();
QString open;
open = QFileDialog::getOpenFileName(this,tr("Select FLV Video"), Home.path() , tr("Video Files (*.flv )"));
if ( !open.isNull() ) {
   QString fileName = QFileDialog::getSaveFileName(this, tr("AcetoneISO::Save Video file"),
						      Home.path() + "/AcetoneISO_flv_2_avi",
							               tr("Video (*.avi)"));
   if ( !fileName.isNull() ) {
      QString file;
      file = fileName.append(".avi" );
      FLv.start("mencoder",QStringList()  << "-ovc" << "lavc" << "-lavcopts" << "vcodec=mpeg4:vbitrate=1000:mbd=2:v4mv:autoaspect" << "-vf" << "pp=lb" << "-oac" << "mp3lame" << "-lameopts" << "cbr:preset=128" << open << "-o" << file  );
      progBarra();
     }
   }
}
//  mencoder -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=1000:mbd=2:v4mv:autoaspect -vf pp=lb -oac mp3lame -lameopts cbr:preset=128 /home/bullet/Desktop/a.flv -o "/home/bullet/Desktop/testing.avi"
void acetoneiso::rip()
{
QMessageBox::information(this, "AcetoneISO",tr("Please be sure the DVD disc is inserted in device and then press OK."));
QDir bin("/usr/bin");
QDir::setCurrent( bin.path() );
RIp.start("mencoder",QStringList() <<  "dvd://" << "-oac" << "mp3lame" << "-ovc" << "xvid" << "-xvidencopts" << "pass=1" << "-o" << "/dev/null" );
progBarra();
}

void acetoneiso::printOutrip(int, QProcess::ExitStatus)
{
int valore_uscita = RIp.exitCode();
if(valore_uscita == 0) {
   QMessageBox::information(this, "AcetoneISO",tr("Encoding Pass 1 has succesfully finished.\nPass 2 will be done now. Please choose the bitrate in the next dialog and then choose where to save the video."));
   bool ok;
   int i = QInputDialog::getInteger(this, tr("AcetoneISO::Bitrate"),tr("Please insert Bitrate. Higher bitrate means more quality but will generate a bigger file."), 896, 384, 4096, 128, &ok);
   if (!ok) {
      return;
     }
    else {
       QString file;
       file = QString::number(i).prepend("pass=2:bitrate=" );
       QDir Home = QDir::home();
       QString fileName = QFileDialog::getSaveFileName(this, tr("AcetoneISO::Save Video file"),
						      Home.path() + "/AcetoneISO_Rip_DVD_Video",
							                   tr("Video (*.avi)"));
       if ( !fileName.isNull() ) {
//QMessageBox::information(this, "AcetoneISO", file);
          RIp2.start("mencoder",QStringList()  << "dvd://" << "-oac" << "mp3lame" << "-ovc" << "xvid" << "-xvidencopts" << file << "-o" << fileName  );
          progBarra();
         }
        }
  }
else
   QMessageBox::critical(this, "AcetoneISO","Process Error Code: " + QString::number(valore_uscita) );
}

void acetoneiso::printOutrip2(int, QProcess::ExitStatus)
{
int valore_uscita = RIp2.exitCode();
if(valore_uscita == 0)
   QMessageBox::information(this, "AcetoneISO",tr("Process Succesfully Finished!"));
else
   QMessageBox::critical(this, "AcetoneISO","Process Error Code: " + QString::number(valore_uscita) );
}
/*


konsole -e mencoder dvd:// -oac mp3lame -ovc xvid -xvidencopts pass=1 -o /dev/null

konsole --noclose -e mencoder dvd:// -oac mp3lame -ovc xvid -xvidencopts pass=2:bitrate=800 -o "$OUT"

*/



